/****************************************************************
 *
 *        Copyright 2013, Big Switch Networks, Inc.
 *
 * Licensed under the Eclipse Public License, Version 1.0 (the
 * "License"); you may not use this file except in compliance
 * with the License. You may obtain a copy of the License at
 *
 *        http://www.eclipse.org/legal/epl-v10.html
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific
 * language governing permissions and limitations under the
 * License.
 *
 ***************************************************************/

/**
 * @defgroup uCli uCli - Micro Command Line Interface
 *

The uCli module provides a framework for disjoint modules to define
and register CLI components with a CLI managing instance.  Modules
define tables that map CLI commands to functionality.

The uCli infrastructure is used for all command line interfaces and
for options processing for all targets.



 *
 * @{
 *
 * @defgroup ucli-ucli uCli Public Interface
 * @defgroup ucli-module uCli Command Modules
 * @defgroup ucli-node uCli Command Nodes
 * @defgroup ucli-datatypes uCli Datatype Management
 * @defgroup ucli-argparse uCli Argument Parsing
 * @defgroup ucli-config Compile-Time Configuration
 * @defgroup ucli-porting Porting Macros
 *
 * @}
 *
 */
